﻿function SceneBanner(banners_) {

    this.banners = banners_;
    var bannerIdx = -1;
    var blockNaviBanner = false;
    var gTimer1;
    var gTimer2;

    this.show = function() {
        alertMy("SceneBanner.show");

        if (bannerIdx === (this.banners.banner_count - 1)) {
            bannerIdx = 0;
        } else {
            bannerIdx++;
        }

        if (this.banners.banner_items[bannerIdx].id != '') {

            if (STAT) {
                controller.metrika('Показ баннера/' + this.banners.banner_items[bannerIdx].id);
            } 
            
            $("#Main").fadeOut(500);
            
            alertMy("this.banners.banner_items[bannerIdx].path " + this.banners.banner_items[bannerIdx].path);
            ImageViewer.InitPlayer(this.banners.banner_items[bannerIdx].path);
            ImageViewer.SetPlayerProperty(2, "3", 0);


            if (this.banners.banner_items[bannerIdx].buffering != '') {
                ImageViewer.SetInitialTimeOut(this.banners.banner_items[bannerIdx].buffering);
                ImageViewer.SetInitialBuffer(500 * 1024);
                ImageViewer.SetTotalBufferSize(500 * 1024);
                ImageViewer.SetPendingBuffer(500 * 1024);
            }

            if (this.banners.banner_items[bannerIdx].unblock_time != '') {
                gTimer1 = setTimeout("Banner.unblockBanner()", this.banners.banner_items[bannerIdx].unblock_time);
            }

            ImageViewer.OnConnectionFailed = 'Banner.OnConnectionFailed';
            ImageViewer.OnNetworkDisconnected = 'Banner.OnNetworkDisconnected';
            ImageViewer.OnRenderError = 'Banner.OnRenderError';
            ImageViewer.StartPlayback();
            blockNaviBanner = true;

            if (this.banners.banner_items[bannerIdx].time == '') {
                if (MODELYEAR != '2011') {
                    ImageViewer.OnRenderingComplete = 'Banner.bannerPleerOnRenderingComplete';
                } else {
                    gTimer2 = setTimeout("Banner.stopBanner()", this.banners.banner_items[bannerIdx].time2011);
                }
            } else {
                clearTimeout(gTimer2);
                gTimer2 = setTimeout("Banner.stopBanner()", this.banners.banner_items[bannerIdx].time);
            }

        } else {
            this.showMainScene();
        }
    }
    
    this.stopBanner = function() {
        alertMy("SceneBanner.stopBanner");
        ImageViewer.Stop();
        controller.hideKeyHelpBanner();
        this.showMainScene();
    }
    
    this.showMainScene = function() {
        alertMy("SceneBanner.showMainScene");
        $("#Main").fadeIn(500);
        CURRENT.scene = SceneMainMain;
        CURRENT.scene.initMainpage(MelodyData, UserInfo);
    }

    this.bannerPleerOnRenderingComplete = function() {
        alertMy("SceneBanner.bannerPleerOnRenderingComplete");
        this.stopBanner();
    }

    this.unblockBanner = function() {
        alertMy("SceneBanner.unblockBanner");
        blockNaviBanner = false;
        controller.showKeyHelpBanner();
    }
    
    this.OnConnectionFailed = function() {
        alertMy("SceneBanner.OnConnectionFailed");
        ImageViewer.Stop();
        controller.getJsonDataError();
    }

    this.OnNetworkDisconnected = function() {
        alertMy("SceneBanner.OnNetworkDisconnected");
        ImageViewer.Stop();
        controller.getJsonDataError();
    }

    this.OnRenderError = function() {
        alertMy("SceneBanner.OnRenderError");
        ImageViewer.Stop();
        controller.getJsonDataError();
    }

    
    
//------------------------------------------------------------------------------
//--- клавиатура ---------------------------------------------------------------
//------------------------------------------------------------------------------
    this.key_LEFT = function() {
        alertMy("SceneBanner.key_LEFT");
    }
    this.key_RIGHT = function() {
        alertMy("SceneBanner.key_RIGHT");
    }
    this.key_UP = function() {
        alertMy("SceneBanner.key_UP");
    }
    this.key_DOWN = function() {
        alertMy("SceneBanner.key_DOWN");
    }
    this.key_ENTER = function() {
        alertMy("SceneBanner.key_ENTER");
        if (!blockNaviBanner) {
            this.stopBanner();
        }

    }
    this.key_ESC = function() {
        alertMy("SceneBanner.key_ESC");
        if (TV) {
            widgetAPI.blockNavigation(event);
            if (!blockNaviBanner) {
                this.stopBanner();
            }
        }
    }

}