﻿var controller = {
}

controller.soundValue = 8;

controller.start = function() {
    alertMy("controller.start");
    controller.getDataFirst(firstUrl);
}



//Покажем панель баннера 
controller.showKeyHelpBanner = function() {
    alertMy("controller.showKeyHelpBanner");
    $("#BannerKeyHelpBar").fadeIn(500);
}
//Скроем панель баннера
controller.hideKeyHelpBanner = function() {
    alertMy("controller.hideKeyHelpBanner");
    $("#BannerKeyHelpBar").fadeOut(100);
}
//Скроем логотип
controller.hideLogo = function() {
    alertMy("controller.hideLogo");
    document.getElementById("MainHeader").style.visibility = "hidden";
}
controller.hideLoading = function() {
    alertMy("controller.hideLoading");
    blockNavi = 0;
    document.getElementById("content-loading").style.visibility = "hidden";
}
controller.showLoading = function() {
    alertMy("controller.showLoading");
    blockNavi = 1;
    document.getElementById("content-loading").style.visibility = "visible";
}

//******************************************************************************
//Получение данных с сайта - Мелодия
//******************************************************************************
controller.getDataNextLevel = function(user) {
    alertMy("controller.getData");

    var url = HOST + TOKEN + "&cmd=nextlevel" + "&user=" + user;

    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.getJsonData,
        error: controller.getJsonDataError
    });
}

controller.getJsonData = function(data) {
    alertMy("dataFromServer = data");
    alertMy(data);
    if (data == undefined) {
        controller.getJsonDataError();
    } else {
        SceneMainMain = new SceneMain();
        dataFromServerMelody = data;
        CURRENT.playMelody = -1;
        SceneMessageLevelOk = new SceneMessage(dataFromServerMelody.message_guessed_level);
        SceneMessageNoMoney = new SceneMessage(dataFromServerMelody.message_no_money);
        SceneMessageExit = new SceneMessage(dataFromServerMelody.message_exit);
        SceneMessageGameOver = new SceneMessage(dataFromServerMelody.message_game_over);
        SceneMessageRules = new SceneMessage(dataFromServerMelody.message_rules);
        SceneMessageRulesFirst = new SceneMessage(dataFromServerMelody.message_rules_first);
        
        if (CURRENT.rules) {
            CURRENT.rules = false;
            CURRENT.scene = SceneMessageRulesFirst;
            CURRENT.scene.initMessagePage();
        } else {
            controller.nextPlayMelody();
        }
    }
}

//*********************

controller.getDataFirst = function(url) {
    alertMy("controller.getDataFirst");
    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.getJsonDataFirst,
        error: controller.getJsonDataError
    });
}

controller.getJsonDataFirst = function(data) {
    alertMy("dataFromServer = data");
    alertMy(data);
    if (data == undefined) {
        controller.getJsonDataError();
    } else {
        dataFromServerFirst = data;
        Banner = new SceneBanner(dataFromServerFirst);
        controller.getDataNextLevel(dataFromServerFirst.id_user);
    }
}

//*********************

controller.setDataIhfo = function(id, level, money) {
    alertMy("controller.setDataIhfo");

    var url = HOST + TOKEN + "&cmd=setdatainfo&user=" + UserInfo.id_user + "&melody=" + id + "&money=" + money + "&level=" + level + "&sessid=" + SESID;

    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.setJsonDataIhfo,
        error: controller.getJsonDataError
    });
}

controller.setJsonDataIhfo = function(data) {
    alertMy("dataFromServer = data");
    alertMy(data);
    if (data == undefined) {
        controller.getJsonDataError();
    } else {
        alertMy("setJsonDataIhfo data = " + data);
    }
}

//*********************

controller.getUserMoney = function() {
    alertMy("controller.getUserMoney");

    var url = HOST + TOKEN + "&cmd=getusermoney&user=" + UserInfo.id_user;

    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.getJsonUserMoney,
        error: controller.getJsonDataError
    });
}

controller.getJsonUserMoney = function(data) {
    alertMy("getJsonUserMoney dataFromServer = data");
    alertMy(data);
    if (data == undefined) {
        controller.getJsonDataError();
    } else {
        dataFromServerUserMoney = data;
        UserInfo.user_money = dataFromServerUserMoney.user_money;
        CURRENT.scene.showInfo();
    }
}


//*********************

controller.setUserMoney = function() {
    alertMy("controller.setUserMoney");

    var url = HOST + TOKEN + "&cmd=setusermoney&user=" + UserInfo.id_user + "&money=" + UserInfo.user_money + "&sessid=" + SESID;

    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.setJsonUserMoney,
        error: controller.getJsonDataError
    });
}

controller.setJsonUserMoney = function(data) {
    alertMy("dataFromServer = data");
    alertMy(data);
    if (data == undefined) {
        controller.getJsonDataError();
    } else {
        alertMy("setJsonUserMoney data = " + data);
    }
}

controller.getJsonDataError = function() {
    alertMy("controller.getJsonDataError");
    
    Pleer.stopMP3();
    document.getElementById("ErrorMessage").style.visibility = "visible";
    blockNavi = 1;    
}

//******************************************************************************
controller.nextPlayMelody = function() {
    alertMy("controller.nextPlayMelody");

    alertMy("dataFromServerMelody.melody_items_guessed_count = " + dataFromServerMelody.melody_items_guessed_count);


    CURRENT.playMelody++;
    
    if (dataFromServerMelody.melody_items_count != 0) {

        if (CURRENT.playMelody < dataFromServerMelody.melody_items_count) {


            MelodyData = dataFromServerMelody.melody_items[CURRENT.playMelody];
            alertMy("!!!!!!!!!!!!!!!! Начинаем угадывать мелодию = " + CURRENT.playMelody);

            if (MelodyData.melody_guessed == '0') {
                alertMy("!!!!!!!!!!!!!!!! Пока не угадана Разгадываем");
                
                if (STAT) {
                    controller.metrika('Угадываем мелодию/' + MelodyData.melody_singer + '-' + MelodyData.melody_caption);
                }
                
                Pleer.initialaize = false;
                Pleer.PleerStop();
                
                UserInfo = dataFromServerFirst;

                SceneMessageTips1 = new SceneMessage(dataFromServerMelody.messages_tips[0]);
                SceneMessageTips2 = new SceneMessage(dataFromServerMelody.messages_tips[1]);
                SceneMessageTips3 = new SceneMessage(dataFromServerMelody.messages_tips[2]);

                SceneMessageTipsImage = new SceneMessage(dataFromServerMelody.messages_tips[3]);

                SceneMessageОК = new SceneMessage(MelodyData.messages[0]);
                SceneMessageERR = new SceneMessage(MelodyData.messages[1]);

                CURRENT.scene = Banner;
                CURRENT.scene.show();

            } else {
                alertMy("!!!!!!!!!!!!!!!! Уже угадана");
                controller.nextPlayMelody();
            }
        } else {
            if (controller.isLevelGuessed(dataFromServerMelody)) {
                alertMy("!!!!!!!!!!!!!!!! Уровень пройден");
                
                controller.metrika('Пройден уровень/' + UserInfo.user_level);
                
                CURRENT.scene = SceneMessageLevelOk;
                SceneMessageLevelOk.initMessagePage();

            } else {
                CURRENT.playMelody = -1;
                controller.nextPlayMelody();
            }
        }
    } else {
        CURRENT.scene = SceneMessageGameOver;
        CURRENT.scene.initMessagePage();
    }
    

}

controller.isLevelGuessed = function(melodies) {
    alertMy("controller.isLevelGuessed");
    alertMy("melody_items_guessed_count = " + melodies.melody_items_guessed_count);
    alertMy("melody_items_count = " + melodies.melody_items_count);
    if (melodies.melody_items_guessed_count == melodies.melody_items_count) {
        return true;
    } else {
        return false;
    }
}

controller.tryAgainMelody = function() {
    alertMy("controller.tryAgainMelody");
    controller.getUserMoney();
    CURRENT.scene = SceneMainMain;
}

controller.getNewLevelFromServer = function() {
    alertMy("controller.getNewLevelFromServer");
    controller.getDataNextLevel(dataFromServerFirst.id_user);
}

controller.removeUnnecessary = function() {
    alertMy("controller.removeUnnecessary");
    
    if (STAT) {
        controller.metrika('Подсказки по типу/Удалить лишние буквы');
        controller.metrika('Подсказка_по_мелодии/' + MelodyData.melody_singer + '-' + MelodyData.melody_caption);
    }
    
    CURRENT.scene = SceneMainMain;
    SceneMainMain.setReturnUserAnswerItemsAll();
    MelodyData.keyboard_items_user_tips_used = 1;
    MelodyData.user_tips_items[1].tips_used = 1;
    UserInfo.user_money = UserInfo.user_money - MelodyData.user_tips_items[1].tips_money;
    controller.setUserMoney();
    SceneMainMain.showKeyboard();
    SceneMainMain.showTips();
    SceneMainMain.showInfo();
}

controller.openAnswerItem = function() {
    alertMy("controller.openAnswerItem");
    
    if (STAT) {
        controller.metrika('Подсказки по типу/Открыть случайную букву');
        controller.metrika('Подсказка_по_мелодии/' + MelodyData.melody_singer + '-' + MelodyData.melody_caption);
    }
    
    CURRENT.scene = SceneMainMain;
    SceneMainMain.setReturnUserAnswerItemsAll();
    SceneMainMain.OpenRandomAnswerItem();
    UserInfo.user_money = UserInfo.user_money - MelodyData.user_tips_items[2].tips_money;
    controller.setUserMoney();
    SceneMainMain.showAnswer();
    SceneMainMain.showKeyboard();
    SceneMainMain.showInfo();

    if (SceneMainMain.isResult()) {
        if (SceneMainMain.checkResult()) {
            SceneMainMain.showResult(1);
        } else {
            SceneMainMain.showResult(0);
        }
    }


}

controller.openImage = function() {
    alertMy("controller.openImage");
    
    if (STAT) {
        controller.metrika('Подсказки по типу/Открыть картинку');
        controller.metrika('Подсказка_по_мелодии/' + MelodyData.melody_singer + '-' + MelodyData.melody_caption);
    }
    
    CURRENT.scene = SceneMainMain;
    MelodyData.user_tips_image_used = 1;
    CURRENT.scene.zone = 2;
    UserInfo.user_money = UserInfo.user_money - MelodyData.user_tips_image_money;
    controller.setUserMoney();
    SceneMainMain.showImage();
    SceneMainMain.showKeyboard();
    SceneMainMain.showInfo();

}

controller.isMoney = function(money_tips) {
    alertMy("controller.isMoney");
    var m = UserInfo.user_money - money_tips;
    if (m >= 0) {
        return true;
    } else {
        return false;
    }
}

controller.actionExit = function() {
    alertMy("controller.actionExit");
    if (TV) {
        widgetAPI.blockNavigation(event);
        pluginAPI.unregistAllKey();
        widgetAPI.sendReturnEvent();
    }

}

//Статистика -------------------------------------------------------------------
controller.setStat = function(url) {
    alertMy("controller.setStat");
    alertMy("$.ajax " + url);
    $.ajax({
        type: "get",
        dataType: "json",
        url: url,
        success: controller.setStatJson,
        error: function() {
            alertMy("json error!!");
        }
    });
}

controller.setStatJson = function(data) {
    alertMy("setStatJson = data");
    alertMy(data.result);
}

controller.metrika = function(str) {
    alertMy("controller.metrika = " + str);
    yaCounter26004489.hit("http://melody.tv/" + str,str,null);
}

//Статистика---


//Обработка нажатия клавиш -----------------------------------------------------
function keyDown(event) {
    alertMy("keyDown");
    if (blockNavi == 0) {
        alertMy("keyDown(" + event.keyCode + ")");
        switch (event.keyCode) {
            case tvKey.KEY_LEFT:
                CURRENT.scene.key_LEFT();
                break;

            case tvKey.KEY_RIGHT:
                CURRENT.scene.key_RIGHT();
                break;

            case tvKey.KEY_UP:
                CURRENT.scene.key_UP();
                break;

            case tvKey.KEY_DOWN:
                CURRENT.scene.key_DOWN();
                break;

            case tvKey.KEY_ENTER:
                CURRENT.scene.key_ENTER();
                break;

            case tvKey.KEY_INFO:
                controller.key_info();
                break;

            case tvKey.KEY_PLAY:
                CURRENT.scene.key_Play();
                break;

            case tvKey.KEY_PAUSE:
                CURRENT.scene.key_Pause();
                break;

            case tvKey.KEY_STOP:
                CURRENT.scene.key_Stop();
                break;

            case tvKey.KEY_RED:
                CURRENT.scene.key_9();
                break;

            case tvKey.KEY_GREEN:
                CURRENT.scene.key_0();
                break;

            case tvKey.KEY_YELLOW:
                CURRENT.scene.key_c();
                break;

            case tvKey.KEY_BLUE:
                CURRENT.scene.key_d();
                break;

            case tvKey.KEY_9:
                if (!TV) {
                    CURRENT.scene.key_9();
                }
                break;

            case tvKey.KEY_0:
                if (!TV) {
                    CURRENT.scene.key_0();
                }
                break;

            case tvKey.KEY_7:
                if (!TV) {
                    CURRENT.scene.key_c();
                }
                break;

            case tvKey.KEY_8:
                if (!TV) {
                    CURRENT.scene.key_d();
                }
                break;

            case tvKey.KEY_1:
                if (!TV) {
                    CURRENT.scene.key_Play();
                }
                break;

            case tvKey.KEY_2:
                if (!TV) {
                    CURRENT.scene.key_Stop();
                }
                break;

            case tvKey.KEY_RETURN:
                CURRENT.scene.key_ESC();
                break;

            case tvKey.KEY_EXIT:
                widgetAPI.blockNavigation(event);
                pluginAPI.unregistAllKey();
                widgetAPI.sendExitEvent();
                break;

            case tvKey.KEY_VOL_UP:
                controller.soundUP();
                break;

            case tvKey.KEY_VOL_DOWN:
                controller.soundDOWN();
                break;

        }
    } else {
        switch (event.keyCode) {
            case tvKey.KEY_RETURN:
                if (TV) {
                    widgetAPI.blockNavigation(event);
                    pluginAPI.unregistAllKey();
                    widgetAPI.sendReturnEvent();
                }
                break;

            case tvKey.KEY_EXIT:
                widgetAPI.blockNavigation(event);
                pluginAPI.unregistAllKey();
                widgetAPI.sendExitEvent();
                break;
        }
    }
}


// громкость
controller.showSound = function() {
    alertMy("controller.showSound " + soundFlag);

    document.getElementById("SoundHelpBarText").innerHTML = controller.soundValue;

    if (!soundFlag) {
        alertMy("controller.showSound SoundHelpBar = visible");
        soundFlag = true;
        document.getElementById("SoundHelpBar").style.visibility = "visible";
        clearTimeout(gTimerSound);
        gTimerSound = setTimeout('controller.hideSound();', 5000);
    }
}

controller.hideSound = function() {
    alertMy("controller.hideSound");
    soundFlag = false;
    document.getElementById("SoundHelpBar").style.visibility = "hidden";
}

controller.soundValueInit = function() {
    alertMy("controller.soundValueInit");
    controller.soundValue = 8;
    //controller.soundValue = SefPlugin.Execute("GetVolume");
    alertMy("controller.soundValue = " + controller.soundValue);
}

controller.soundUP = function() {
    alertMy("controller.soundUP controller.soundValue=" + controller.soundValue);

    if (controller.soundValue > 99) {
        controller.soundValue = 100;
    } else {
        controller.soundValue = controller.soundValue + 1;
    }
    controller.showSound();
    deviceapis.audiocontrol.setVolume(parseInt(controller.soundValue));
}

controller.soundDOWN = function() {
    alertMy("controller.soundDOWN controller.soundValue=" + controller.soundValue);

    if (controller.soundValue < 1) {
        controller.soundValue = 0;
    } else {
        controller.soundValue = controller.soundValue - 1;
    }
    controller.showSound();
    deviceapis.audiocontrol.setVolume(parseInt(controller.soundValue));
}

